/* FeatureIDE - An IDE to support feature-oriented software development
 * Copyright (C) 2005-2012  FeatureIDE team, University of Magdeburg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see http://www.gnu.org/licenses/.
 *
 * See http://www.fosd.de/featureide/ for further information.
 */
package de.ovgu.featureide.fm.ui.views.outline;

import de.ovgu.featureide.fm.core.Feature;

/**
 * holds information for the GroupStates of features in outline views
 * 
 * @author Jan Wedding
 */
public class FmOutlineGroupStateStorage {
	private Feature feature;
	private boolean isOrGroup;

	public FmOutlineGroupStateStorage(Feature parentFeature, boolean isOr) {
		feature = parentFeature;
		isOrGroup = isOr;
	}

	public boolean isOrGroup() {
		return isOrGroup;
	}

	public Feature getFeature() {
		return feature;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((feature == null) ? 0 : feature.hashCode());
		return prime * result + (isOrGroup ? 1231 : 1237);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		FmOutlineGroupStateStorage other = (FmOutlineGroupStateStorage) obj;
		if (feature == null) {
			if (other.feature != null)
				return false;
		} else if (!feature.equals(other.feature))
			return false;
		if (isOrGroup != other.isOrGroup)
			return false;
		return true;
	}

}
