package refactor;

import mixin.AstNode;
import mixin.QName;




/**
 * @author Stephan Klapproth
 * @layer<typesys>
 *
 */
class ClassReference implements Declaration, AstElement {

    private QName node;
    
    private ClassInfo clazz;
    
    private Scope context;
    
    ClassReference(ClassInfo aClass, QName aNode) {
        clazz = aClass;
        node = aNode;
    }
    
    public ClassInfo getReferencedClass() {
        return clazz;
    }
    
    public int endLineNum() {
        return startLineNum();
    }

    public AstNode getAstNode() {
        return node;
    }

    public int startLineNum() {
        return node.findToken().lineNum();
    }

    public Scope getContext() {
        return context;
    }

    public void setContext(Scope aScope) {
        context = aScope;
    }

    public String getFullName() {
        return clazz.getFullName();
    }

    public String getName() {
        return clazz.getName();
    }
}
