package refactor;




class FieldAccessConflict2 extends Conflict {

    private FieldAccess access;

    private FieldInfo field;

    private ModifierInfo modifier;

    public FieldAccessConflict2(FieldAccess anAccess, ModifierInfo aModifier) {
        super();
        access = anAccess;
        field = anAccess.getField();
        modifier = aModifier;
    }

    public String getDescription() {
        StringBuilder tmpDesc = new StringBuilder();
        tmpDesc.append("After refactoring, reference to ");
        tmpDesc.append(modifier + " ");
        tmpDesc.append("field ");
        tmpDesc.append(field.getName());
        return tmpDesc.toString();
    }

    public int startLine() {
        return access.startLineNum();
    }

    public int endLine() {
        return access.endLineNum();
    }

    public String getFile() {
        return ((ClassInfoAst) TypesysUtil.getDeclaringClass(access))
                .getSrcFile().getAbsolutePath();
    }

}
