package refactor;

import mixin.AstCursor;
import mixin.AstNode;
import mixin.CaseLabel;
import mixin.SEBod;
import mixin.SwitchStmt;




/**
 * 
 * @layer<typesys>
 * @author Stephan Klapproth
 * 
 */
class SwitchScope extends AbstractBlockScope {

    private SwitchStmt node;

    SwitchScope(SwitchStmt aNode) {
        node = aNode;
    }
    
    void init() {
        super.init();
        initExpression(node.getExpression());
        initSwitchEntries();
    }

    private void initSwitchEntries() {
        if (node.getAST_SwitchEntry() == null) {
            return;
        }
        AstCursor c = new AstCursor();
        for (c.FirstElement(node.getAST_SwitchEntry()); c.MoreElement(); c
                .NextElement()) {
            if (!(c.node instanceof SEBod)) {
                continue;
            }
            SEBod tmpSEBod = (SEBod) c.node;
            if (tmpSEBod.getSwitchLabel() instanceof CaseLabel) {
                initExpression(((CaseLabel) tmpSEBod.getSwitchLabel())
                        .getExpression());
            }
            if (tmpSEBod.getAST_Stmt() != null) {
                initStatements(tmpSEBod.getAST_Stmt());
            }
        }
    }

    public AstNode getAstNode() {
        return node;
    }
}
